let config = require('./config/config.js')
const Http = require("./utils/HttpBasics");
App({
  data: {},
  onLaunch: function(options) {
    var that = this;
    that.globalData.sceneAddress = options.scene;
    that.getLocation()
    that.userLogin()
  },
  /**
   * 获取地址位置信息
   */
  getLocation: function() {
    wx.getLocation({
      type: 'wgs84',
      success: function(res) {
        console.log("getLocation", res);
      },
      fail: error => {
        console.log(error);
      }
    })
  },
  /**
   * 用户登录
   */
  userLogin: function() {
    var that = this;
    // 登录
    wx.login({
      success: ({
        code
      }) => {
        Http.post({
          url: config.api.login,
          data: {
            appId: config.weapp.AppId,
            code: code,
            sceneAddress: that.globalData.sceneAddress,
          }
        }).then(res => {
          console.log("req", res);
          that.globalData.token = res.data.token;
          Http.setToken(res.data.token)
          that.checkUserCarStatus()
          that.getUserInfo()
          if (that.couponChannelListCallback) {
            that.couponChannelListCallback(that.globalData.token);
          }
          if (that.couponListCallback) {
            that.couponListCallback(that.globalData.token);
          }
          return Http.post({
            url: config.api.checkUserStatus,
            data: {}
          })
        }).then(res => {}).catch(err => {
          console.log(err)
          if (err.code == 11004) {
            // 用户昵称未授权
            wx.redirectTo({
              url: '../getuserinfo/index',
            })
          }
        })
      }
    })
  },
  /**
   * 获取用户信息
   */
  getUserInfo: function() {
    // 获取用户信息
    wx.getSetting({
      success: res => {
        console.log('getSetting', res)
        if (res.authSetting['scope.userInfo']) {
          // 已经授权，可以直接调用 getUserInfo 获取头像昵称，不会弹框
          wx.getUserInfo({
            success: res => {
              // 可以将 res 发送给后台解码出 unionId
              console.log('getUserInfo', res)
            }
          })
        }
      }
    })
  },
  /**
   * 检查用户是否有车
   */
  checkUserCarStatus: function() {
    var that = this
    Http.get({
      url: config.api.userCarCount,
      data: {}
    }).then(res => {
      if (res.data > 0) {
        // 用户名下有车
        that.globalData.phone = res.data.phone
        that.globalData.supportCar = true
        // 共同登录
      }
    })
  },
  /**
   * car共同登录
   */
  userCarLogin: function() {
    var that = this
    // 共同登录
    Http.post({
      url: config.api.carInit,
      data: {
        phone: this.globalData.phone
      }
    }).then(res => {
      that.globalData.parkVendor = res.data.parkVendor
      if (res.data.token != "undefined") {
        that.globalData.etcpToken = res.data.token
      }
    })
  },
  globalData: {
    // token
    token: null,
    // 渠道
    sceneAddress: null,
    // 二维码参数
    scene: null,
    // 支持智慧停车, 用户名下有车
    phone: null,
    supportCar: false,
    parkVendor: 1, // 1: ETCP, 2: TJD
    // ETCP token
    etcpToken: null,
    // 当前商场信息
    market: {
      name: "陕西大悦城"
    }
  }
})