// pages/forgetpwd/forgetpwd.js
let config = require('../../../config/config.js')
let Http = require('../../../utils/HttpBasics')
const app = getApp()

Page({
  data: {
    phone: '',
    yzm: '',
    flag: true,
    retry: false,
    time: 60,
    couponId: null,
  },
  getYZM(e) {
    this.setData({
      phone: e.detail.value.phone,
      yzm: e.detail.value.yzm
    })
  },
  next() {
    var that = this
    console.log(that.data.yzm)
    Http.get({
        url: config.api.validationCode,
        data: {
          phone: that.data.phone,
          code: that.data.yzm,
          type: 1,
          appid: app.globalData.appId
        }
      })
      .then(res => {
        wx.redirectTo({
          url: '../coupon/detail/index?id=' + that.data.couponId + "&flag=pay",
        })
      })
      .catch(error => {
        wx.showToast({
          title: error.data,
        })
      })
  },
  send() {
    var phoneReg = /(^1[3|4|5|7|8]\d{9}$)|(^09\d{8}$)/;
    if (phoneReg.test(this.data.phone)) {
      this.setData({
        flag: false,
        retry: true
      })
      Http.get({
          url: config.api.sendValidationCode,
          data: {
            phone: this.data.phone,
            code: this.data.yzm,
            type: 1,
            appid: app.globalData.appId
          }
        })
        .then(res => {
          console.log(res)
          var timer = setInterval(() => {
            this.data.time--
              this.setData({
                time: this.data.time
              })
            if (this.data.time == 0) {
              clearInterval(timer)
              this.setData({
                flag: true,
                retry: false,
                time: 60
              })
            }
          }, 1000)
        })
        .catch(error => {
          wx.showToast({
            title: '请输入有效手机号',
          })
        })
    }
  }
})